
ChiliProject - Bug # 667: Label all input field and control tags

Status: Closed Priority: Normal
Author: Romano Licker Category: User interface
Created: 2011-10-18 Assignee: Holger Just
Updated: 2011-10-28 Due date:
Remote issue URL:
Affected version:
Description: Accessibility flaw for blind users:

Text areas, check boxes etc. need to be labeled with a <label for="id"> tag, in order to be linked to their 
description.
This needs to happen for a elements if possible.

Associated revisions
2011-10-28 05:03 pm - Romano Licker
[#667] added style to hide content from sighted users

2011-10-28 05:03 pm - Romano Licker
[#667] added 'for' to link them

2011-10-28 05:03 pm - Romano Licker
[#667] added invisible project scope label

2011-10-28 05:03 pm - Romano Licker
[#667] added invisible search label

2011-10-28 05:03 pm - Romano Licker
[#667] added invisible labels for queries

2011-10-28 05:03 pm - Romano Licker
[#667] linked labels to their elements

2011-10-28 05:03 pm - Romano Licker
[#667] link label to element

2011-10-28 05:03 pm - Romano Licker
[#667] link label to element

2011-10-28 05:03 pm - Romano Licker
[#667] set id for message_subject and linked it to label,
added invisible label

2011-10-28 05:03 pm - Romano Licker
[#667] set unique id for each checkbox and linked it
added "no-css" class to overwrite the current label style

2011-10-28 05:03 pm - Romano Licker
[#667] added invisible labels for reassign select-tag on destroy views

2011-10-28 05:03 pm - Romano Licker
[#667] linked labels to their elements

2011-10-28 05:03 pm - Romano Licker
[#667] linked label to its element

2011-10-28 05:03 pm - Romano Licker
[#667] added invisible label for mail notification,
linked label where possible

2011-10-28 05:03 pm - Romano Licker
[#667] added invisible label

2011-10-28 05:03 pm - Romano Licker
[#667] added invisible label

2011-10-28 05:03 pm - Romano Licker
[#667] link label to element

2011-10-28 05:03 pm - Romano Licker
[#667] linked labels to their element

2011-10-28 05:03 pm - Romano Licker
[#667] set ids, created invisible labels and linked them

2011-10-28 05:03 pm - Romano Licker
[#667] linked label to its element

2011-10-28 05:03 pm - Romano Licker
[#667] linked labels to their elements

2011-10-28 05:03 pm - Romano Licker
[#667] made labels visible as this is an accessibility issue
even for sighted users

2011-10-28 05:05 pm - Romano Licker
[#667] improved code readability

2011-10-28 05:10 pm - Holger Just 
[#667] Label all input field and control tags

History
2011-10-18 04:29 pm - Holger Just
Many labels in current forms are not marked up with the @for="id"@ attribute but surround the element which they label, e.g.

<pre><label>Foo <input type="text" name="foo" /></label></pre>

AFAIK, this is also a valid (although less elegant) way for proper markup.

Finally please make sure to provide timely patches if you want to have the feature included into the core for a certain version as they still have to be 
reviewed.

2011-10-19 10:09 am - Romano Licker
I noticed and I will not change these labels. 
However most of the time, the label-tag is not surrounding the element. In those cases I add the "for" attribute to the label and link it.

It should be done within a few days. I will post a pull-request as soon as finished.
2011-10-21 11:26 am - Romano Licker
I completed the task today.

This is the pull request:
https://github.com/chiliproject/chiliproject/pull/110

The last commit is optional. It adds visible labels to the column option view in issue filters.
This is an accessibility flaw for sighted users as well.

2011-10-27 06:35 am - Gregor Schmidt
- Assignee deleted (Romano Licker)

- Status changed from Open to Ready for review

Hello Romano,

as far as I can see, this issue is ready for review. I therefore update the status accordingly.

Thanks for taking the time to go through all the code. I think this is a great enhancement for all users of ChiliProject. I always tend to click on labels and 
expect the focus to move to the input field. With these changes in ChiliProject, it should always work.

Thanks for your effort,

Gregor

2011-10-27 06:37 am - Gregor Schmidt
@everyone:

Is there a policy about newly introduced i18n labels? Is it okay to add a bunch of untranslated labels in minor releases or should we postpone that to 
major releases, so that translators may have the time to do their work?

Gregor

2011-10-27 06:53 am - Gregor Schmidt
I just ran the test suite on 1.8.7 using MySQL. Everything looks good.

2011-10-27 10:12 am - Romano Licker
- Assignee set to Romano Licker

- Status changed from Ready for review to Open

Ourclient's expert on accessibility told us that there are still problems. 

A brief summary:
* Every input/textarea/select/radiobuttons/checkboxes have to be labeled. 
* Even if there are in a fieldset, table .. they need to have an associated label-tag.
* Although tables contain the description in the tableheader, input fields need to have separate labels.
* the label has to be in the same td as the element that you want to label (screenreader navigation issue)
* only exception so far: cloze texts (e.g. in issue filters) -> CHECKBOX Assignee IS (screenreader can read options) ROMANO LICKER (screenreader 
can read options)
The sentence read by the screenreader still makes sense. Textfields in this cloze texts however still need a label.

I will go through all files one more time and add the labels where needed.

2011-10-28 03:14 pm - Holger Just
- Assignee changed from Romano Licker to Holger Just

- Status changed from Open to Closed

I merged the current state of the fixes. Please create a new issue if there are additional views.
